import time
import common
#
from System.Collections.Generic import List
from System import Byte, Int32
#
MaxHonorTargets = 3
ShieldBashTime = 2  # in seconds
lastShieldBashTime = 0  # first bash will be immediate
PetAttackTime = 5  # in seconds
DivineFuryLevel = .60  # Stam at 75% will use Divine Fury
ConsecrateTimeInterval = 8  # refresh every 8 seconds
lastConsecrateTime = 0 # first consecrate immediate
### Only pick 1 of these 3 as they are mutually exclusive
UseMomentumStrike = False   # set to false if you want lightning strike
UseLightningStrike = False 
UseConfidence = True
###
UseHonor = False
TellPetsToAttack = False
#
def whirlwind_available(weapon):
    if weapon == None:
        return None
    abilities = weapon_abilities()
    if abilities == None:
        return None
    primary = abilities[0]
    secondary = abilities[1]
    if primary == 'Whirlwind Attack':
        #Misc.SendMessage("Returning Whirlwing primary", 5)
        return Player.WeaponPrimarySA
    if secondary == 'Whirlwind Attack':
        return Player.WeaponSecondarySA    
    return None

#
#
import re
def weapon_abilities():
    w_r = Player.GetItemOnLayer('RightHand')
    #Misc.SendMessage("right={}".format(w_r))
    w_l = Player.GetItemOnLayer('LeftHand')
    #Misc.SendMessage("left={}".format(w_l))
    ret = None
    if w_l != None: 
        ret = common.default_weapon_abilities(w_l.ItemID)         
        if ret[0] or ret[1]:
            return ret
    if w_r != None:    
        ret = common.default_weapon_abilities(w_r.ItemID) 
        #Misc.SendMessage("Use right")
    return ret
       

#
def weaponspecials(weapon):
    if weapon == None:
        return None
    abilities = weapon_abilities()
    if not abilities:
        return None
    primary = abilities[0]
    secondary = abilities[1]
    #Misc.SendMessage(primary)
    #Misc.SendMessage(secondary)
    if primary == None:
        return None
    if secondary == None:
        return None 
    primary_priority = 999   
    if primary in common.weapon_ability_priority:
        primary_priority = common.weapon_ability_priority[primary]
    secondary_priority = 999    
    if secondary in common.weapon_ability_priority:    
        secondary_priority = common.weapon_ability_priority[secondary]
    suggest_primary = 999
    suggest_secondary = 999
    #
    if not primary in common.requires_mount or Player.Mount != None:
        suggest_primary = primary_priority
    if not secondary in common.requires_mount or Player.Mount != None:
        suggest_secondary = secondary_priority
    if suggest_primary == 999 and suggest_secondary == 999:
        return None
    if primary == "Infectious Strike" and Player.GetSkillValue("Poisoning") < 10:
        suggest_primary = 999    
    if secondary == "Infectious Strike" and Player.GetSkillValue("Poisoning") < 10:
        suggest_secondary = 999    
    if suggest_primary < suggest_secondary:
        return Player.WeaponPrimarySA
    else:
        return Player.WeaponSecondarySA
#
def Use_weapon_special(weapon):
    #Misc.SendMessage("Action for 1")
    action = weaponspecials(weapon)
    if action != None and not Player.HasSpecial :
        #Misc.SendMessage("Do Action for 1")
        action()

#                        
discord_list = {}
next_discord_time = 0
#
def discord(enemy):
    if Player.GetSkillValue("Discordance") < 10: 
        return
    global next_discord_time
    global discord_list
    instrumentID = 0xe9c
    drum = Items.FindByID(instrumentID, -1, Player.Backpack.Serial)
    if drum == None:
        return
    if enemy.Serial in discord_list:
        return
    now = time.time()
    if next_discord_time > time.time():
        return
    Journal.Clear()    
    Player.UseSkill('Discordance') 
    next_discord_time = time.time() + 12
    journal_msg = ""
    limit = time.time() + 1
    while time.time() < limit:
        if Journal.Search("Choose the target"):
            journal_msg = "Choose the target"
            limit = 0  # force out of loop
        if Journal.Search("shall you play"):
            journal_msg = "shall you play"
            limit = 0  # force out of loop
    if journal_msg == "":
        Target.Cancel()
        return # wtf ?
    if journal_msg == "shall you play":
        Target.WaitForTarget(500)
        Target.TargetExecute(drum)
        Misc.Pause(100)
    Target.WaitForTarget(500)
    Target.TargetExecute(enemy)
    Misc.Pause(500)
    Target.Cancel()
    if Journal.Search("play jarring music"):
        discord_list[enemy.Serial] = True
    if Journal.Search("no effect"):
        discord_list[enemy.Serial] = True
    if Journal.Search("already in discord"):
        discord_list[enemy.Serial] = True
    return
    
def IsBoss(enemy):
    if enemy is None:
        return False
    name = enemy.Name
    bosses = ['Master', 'Neira', 'rikktor', 'semidar', 'mephitis' ]
    for boss in bosses:
       if boss.upper() in name.upper():
          return True
    return False      

#
LastPetAttack = 0    
def Attack(enemy):    
    global LastPetAttack
    if TellPetsToAttack:
        if time.time() > LastPetAttack:        
            LastPetAttack = time.time() + PetAttackTime
            for pet in common.FindPets():
                Misc.SendMessage("TELL {} TO ATTACK".format(pet.Name))
                Player.ChatSay(5, "{} Attack".format(pet.Name))
                Target.WaitForTarget(1000)
                Target.TargetExecute(enemy)
    Player.Attack(enemy.Serial)    
    
    
    
Misc.ClearIgnore( )
pets = common.FindPets()
for pet in pets:
    Misc.IgnoreObject(pet)

dont_kill = [ 'a cu sidhe', 'a sheep', 'a dog', 'a cat', 'a horse', 'Dart', 'an energy vortex' ]
ignore_type = [0x007b ]
#0x0190, 0x0191, 
last_attack_msg = time.time()
last_attack_serial = 0
#
last_enemy = None
while True:
    #
    if Player.BuffsExist("Bload Oath"):
        Spells.CastChivalry("Remove Curse", Player.Serial)
        Misc.Pause(1000)
    #
    enemy_filter = Mobiles.Filter()
    enemy_filter.Enabled = True
    enemy_filter.RangeMin = -1
    if Misc.CheckSharedValue("MaxRange"):
        enemy_filter.RangeMax = Misc.ReadSharedValue("MaxRange")
    else:    
        enemy_filter.RangeMax = 1
    enemy_filter.Notorieties = List[Byte](bytes([3,4,5,6]))

    on_me_filter = Mobiles.Filter()
    on_me_filter.Enabled = True
    on_me_filter.RangeMin = -1
    on_me_filter.RangeMax = 1
    on_me_filter.Notorieties = List[Byte](bytes([3,4,5,6]))
    enemies = Mobiles.ApplyFilter(enemy_filter)
    up_close_enemies = Mobiles.ApplyFilter(on_me_filter)
    #Misc.SendMessage("{} enemies up close".format(len(up_close_enemies)))
    
    w_r = Player.GetItemOnLayer('RightHand')
    #Misc.SendMessage("right={}".format(w_r))
    w_l = Player.GetItemOnLayer('LeftHand')
    #Misc.SendMessage("left={}".format(w_l))
    if w_l != None: 
        weapon = w_l
        Misc.Pause(650)
    elif w_r != None:    
        weapon = w_r
        Misc.Pause(650)
    else:
        weapon = None

    if len(enemies) > 0:
        #Misc.SendMessage("{} enemies within 10 squares".format(len(enemies)))
        if not Player.WarMode:
            Player.SetWarMode(True)
        if len(up_close_enemies) > 0 and Player.WarMode:
            enemy = Mobiles.Select(up_close_enemies, 'Nearest')
        else:    
            enemy = Mobiles.Select(enemies, 'Nearest')
        if enemy.Name in dont_kill  or enemy.Body in ignore_type or "wandering healer" in enemy.Name:
            Misc.IgnoreObject(enemy.Serial)
            enemy = None
        # ignore energy vortex
        if enemy and enemy.Body == 0x00A4 and enemy.Hue == 0:    
            Misc.IgnoreObject(enemy.Serial)
            enemy = None
        #if enemy == last_enemy or Player.InRangeMobile(enemy, 3):
            #pass
        #else:
            #Player.PathFindTo(enemy.Position.X, enemy.Position.Y, enemy.Position.Z)
            #last_enemy = enemy   
        if enemy != None:
            if last_attack_serial != enemy.Serial or time.time() > last_attack_msg + 5:
                Mobiles.Message(enemy, 5, "Attacking 0x{:08x}".format(enemy.Serial))
                Player.Attack(enemy.Serial)
                last_attack_msg = time.time()
                last_attack_serial = enemy.Serial
                if UseHonor and (Player.DistanceTo(enemy) > 3) and (enemy.Hits == enemy.HitsMax) and len(enemies) < MaxHonorTargets:
                    Player.InvokeVirtue("Honor")
                    Target.WaitForTarget(1000)
                    Target.TargetExecute(enemy)
            Attack(enemy)
            #Target.AttackTargetFromList("attack")
            #Misc.SendMessage("Notoriety is {}".format(enemy.Notoriety)) 
            if Player.GetSkillValue('Bushido') < 45:
                spell = 'Confidence'
            else:
                spell = 'Counter Attack'
            if False: # FIX ME not Player.SpellIsEnabled( spell ):
                Misc.SendMessage("Casting Bushido2: {}".format(spell))
                Spells.CastBushido( spell )
                Misc.Pause(650)   
            #Misc.SendMessage("{} Active".format(spell))
            if len(enemies) < 700:  
                discord(enemy)         
        if Player.Mana > 25:
            #
            maybeShield = Player.GetItemOnLayer("LeftHand")
            #   
            OtherShieldIDs = [ 0x1B76, 0xa25  ]          
            if time.time() > lastConsecrateTime:
                Spells.CastChivalry('Consecrate Weapon')
                lastConsecrateTime = time.time() + ConsecrateTimeInterval
                Misc.Pause(800)
            elif maybeShield and time.time() > lastShieldBashTime and ("shield" in maybeShield.Name.lower() or maybeShield.ItemID in OtherShieldIDs):                
                Misc.SendMessage("Time to BASH", 5)
                Spells.CastMastery("Shield Bash")
                lastShieldBashTime = time.time() + ShieldBashTime
                Misc.Pause(800)
            #
            elif Player.Stam < (DivineFuryLevel * Player.StamMax ):
                Spells.CastChivalry("Divine Fury")
                Misc.Pause(800)
            if not Player.HasSpecial:
                w_r = Player.GetItemOnLayer('RightHand')
                #Misc.SendMessage("right={}".format(w_r))
                w_l = Player.GetItemOnLayer('LeftHand')
                #Misc.SendMessage("left={}".format(w_l))
                if w_l != None: 
                    weapon = w_l
                    Misc.Pause(650)
                elif w_r != None:    
                    weapon = w_r
                    Misc.Pause(650)
                else:
                    weapon = None
                #
                range = Items.GetPropValue(weapon, 'Range') 
                if range < 2:
                    range = 2         
                on_me_filter.RangeMax = range          
                up_close_enemies = Mobiles.ApplyFilter(on_me_filter)
                #
                num_up_close_enemies = len(up_close_enemies) 
                if IsBoss(enemy):
                    num_up_close_enemies = 1
                    
                if  num_up_close_enemies > 2:
                    action = whirlwind_available(weapon)
                    if action != None:
                        action()
                    elif UseMomentumStrike and (not Player.SpellIsEnabled('Momentum Strike')):    
                        Misc.SendMessage("Momentum Strike", 5)
                        Spells.CastBushido('Momentum Strike')
                        Misc.Pause(800)
                    #    
                    if UseLightningStrike and (not Player.SpellIsEnabled('Lightning Strike')):
                        Misc.SendMessage("Lightning Strike", 5)
                        Spells.CastBushido('Lightning Strike')
                        Misc.Pause(800)
                    elif UseConfidence and (not Player.SpellIsEnabled('Confidence')):
                        Misc.SendMessage("Confidence", 5)
                        Spells.CastBushido('Confidence')
                        Misc.Pause(800)
                    Use_weapon_special(weapon)
                       
                elif len(up_close_enemies) == 2:
                    action = None
                    if UseMomentumStrike:
                        if not Player.SpellIsEnabled('Momentum Strike'):    
                            Misc.SendMessage("Momentum Strike", 5)
                            Spells.CastBushido('Momentum Strike')
                            Misc.Pause(650)
                    else:
                        action = whirlwind_available(weapon)
                    if action != None:
                        action()                       
                    #    
                    if UseLightningStrike and (not Player.SpellIsEnabled('Lightning Strike')):
                        Misc.SendMessage("Lightning Strike", 5)
                        Spells.CastBushido('Lightning Strike')
                        Misc.Pause(800)
                    elif UseConfidence and (not Player.SpellIsEnabled('Confidence')):
                        Misc.SendMessage("Confidence", 5)
                        Spells.CastBushido('Confidence')
                        Misc.Pause(800)
                    #
                    Use_weapon_special(weapon)

                elif not Player.HasSpecial and Player.Mana > 30:                    
                    if UseLightningStrike and (not Player.SpellIsEnabled('Lightning Strike')):
                        Misc.SendMessage("Lightning Strike", 5)
                        Spells.CastBushido('Lightning Strike')
                        Misc.Pause(800)
                    elif UseConfidence and (not Player.SpellIsEnabled('Confidence')):
                        Misc.SendMessage("Confidence", 5)
                        Spells.CastBushido('Confidence')
                        Misc.Pause(800)
                    Use_weapon_special(weapon) 
#                      
    if Player.Weight > (.8 * Player.MaxWeight) or len(Player.Backpack.Contains) > 80 :
        Player.HeadMessage(1, "Heavy") 
    Misc.Pause(100)


